###############################
#
#       nX - Docs
#        (Codename: XEN-Docs)
#
#     This script is a part of
#           XEN CMS
#
#     Writted by NeuroniX
#       aka Viguro Nikolay
#        neuronix666@yandex.ru
#
#          Started at 04/04/04
#
################################

sub DownloadsAdmin
{
   my ($self, %info) = @_;
   my $content;
   my $dir = $info{'dir'};
   
       my %cook = $self->getCookies();
   
      our $ADI = new Libs::ADI ( initMods => 1,
                                               readConf => 1 ); # Initalize ADI constructor

   return $self->saveDown($info{'did'}, 1) if $info{'did'} ne "" && $info{'url'} ne "" && $info{'title'} ne "" && $info{'author'} ne "" && $info{'act'} eq "savenew"; 
   return $self->saveDown($info{'did'}) if $info{'did'} ne "" && $info{'url'} ne "" && $info{'title'} ne "" && $info{'author'} ne "" && $info{'act'} eq "save"; 
   return $self->newDown() if $info{'act'} eq "new";

   $self->delDown($info{'did'}) if $info{'did'} ne "" && $info{'act'} eq "del"; 
   
   $ADI->fsDirDelete($info{'tdir'}, "Downloads") if $info{'act'} eq "dirdel";
   $ADI->fsDirCreate($dir, $info{'dname'}) if $info{'act'} eq "dircreate";
   
   $ADI->fsDirSetGuestVisible($info{'tdir'}, 1) if $info{'act'} eq "guest";
   $ADI->fsDirSetGuestVisible($info{'tdir'}, 0) if $info{'act'} eq "noguest";
   
      return $self->editDown($info{'did'}) if $info{'did'} ne "" && $info{'act'} eq "edit";

############################################
############################################

    $dir = "D0" if $dir eq "";
    $content .= $ADI->viewDirContentAdmin($dir, "D");

    $self->db_connect();

     my $sth = $dbh->prepare("SELECT * FROM ${dbPrefix}_Module_Downloads WHERE FS=\"$dir\"");
           $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
	         {
                    my @html = $self->readFile("Skins/$Libs::API::skin/downloads/ViewAllAdmin.html");

		    $ref->{'Description'} =~ s/&lt;/\</g;
		    $ref->{'Description'} =~ s/&gt;/\>/g;
		    $ref->{'Description'} =~ s/&quot;/\"/g;
		    $ref->{'Description'} =~ s/\&\#58;/:/g;
		    $ref->{'Description'} =~ s/\n/<br>/g;
		    $ref->{'Description'} =~ s/<br>//g;

		   foreach my $line (@html)
		   {
			     $line =~ s/__DATE__/$ref->{'Date'}/eg;
			     $line =~ s/__TITLE__/$ref->{'Title'}/eg;
			     $line =~ s/__DID__/$ref->{'DID'}/eg;
			     $line =~ s/__AUTHOR__/$ref->{'Author'}/eg;
			     $line =~ s/__DESCRIPTION__/$ref->{'Description'}/eg;
			     $line =~ s/__URL__/$ref->{'URL'}/eg;
			     $line =~ s/__DOWNS__/$ref->{'Downs'}/eg;
			     $line =~ s/__RATING__/$ref->{'Rating'}/eg;
			     $line =~ s/__SIZE__/$ref->{'Size'}/eg;

			  	$content .= $line;
                  }
               }

           $sth->finish();

    $self->db_disconnect(); # Disconnecting from DB.
    
    $content .= "<br><table width=100% border=0><form action=admin.cgi method=post><input type=hidden name=do value=\"Downloads\">
		       <input type=hidden name=act value=\"dircreate\"><input type=hidden name=dir value=\"$dir\">
    		       <tr><td align=center><a href=\"admin.cgi?do=Downloads&dir=$dir&act=new\"> </a></td>
    		       <td align=right> : <input type=text name=dname> <input type=submit value=\"\"></td></tr></table><br>";

    return $content;

############################################
############################################

  sub editDown
   {
    my ($self, $did) = @_;
    my $views;

    $self->db_connect(); # Connecting to DB.

     my $sth = $dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Module_Downloads WHERE DID=\"$did\"");
           $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
	         {		    
		    $ref->{'Description'} =~ s/</&lt;/g;
		    $ref->{'Description'} =~ s/>/&gt;/g;
		    $ref->{'Description'} =~ s/\"/&quot;/g;
		    $ref->{'Description'} =~ s/:/\&\#58;/g;
		    $ref->{'Description'} =~ s/<br>/\n/eg;
		    $ref->{'Description'} =~ s/&lt;br&gt;/\n/ig;

                    my @html = $self->readFile("Skins/$Libs::API::skin/downloads/ViewDownAdmin.html");

		   foreach my $line (@html)
		     {
			     $line =~ s/__DATE__/$ref->{'Date'}/eg;
			     $line =~ s/__TITLE__/$ref->{'Title'}/eg;
			     $line =~ s/__DID__/$ref->{'DID'}/eg;
			     $line =~ s/__AUTHOR__/$ref->{'Author'}/eg;
			     $line =~ s/__DESCRIPTION__/$ref->{'Description'}/eg;
			     $line =~ s/__URL__/$ref->{'URL'}/eg;
			     $line =~ s/__DOWNS__/$ref->{'Downs'}/eg;
			     $line =~ s/__RATING__/$ref->{'Rating'}/eg;
			     $line =~ s/__SIZE__/$ref->{'Size'}/eg;

			  	$content .= $line;
                     }
                  }

           $sth->finish();

    $self->db_disconnect(); # Disconnecting from DB.

   return $content;
   }
   
############################################
############################################

sub newDown
{
    my $self = shift;
    my $content;
    my $new;
    my $last = 0;

    $self->db_connect(); # Connecting to DB.
    
    my $sth = $dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Module_Downloads");
           $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
	         {
		     	 if ($ref->{'DID'} > $last)
	  		  {
			    $new = $ref->{'DID'};
		    	  }
			  
			  $last = $ref->{'DID'};	 
		 }
		 
           $sth->finish();
	   
	   $new++;

                  my @html = $self->readFile("Skins/$Libs::API::skin/downloads/ViewDownAdminNew.html");

		   foreach my $line (@html)
		     {
			     $line =~ s/__AUTHOR__/$cook{'login'}/eg;
			     $line =~ s/__DATE__/$Libs::API::localtime;/eg;
			     $line =~ s/__DID__/$new/eg;
			     $line =~ s/__DIR__/$dir/eg;
			     
			  	$content .= $line;
                     }

    $self->db_disconnect(); # Disconnecting from DB.

   return $content;
}
   
############################################
############################################   
   
sub saveDown
{
    my ($self, $did, $new) = @_;
    
		    $info{'desc'} =~ s/&lt;/\</g;
		    $info{'desc'} =~ s/&gt;/\>/g;
		    $info{'desc'} =~ s/&quot;/\"/g;
		    $info{'desc'} =~ s/\&\#58;/:/g;
		    $info{'desc'} =~ s/\n/<br>/g;
		    
	    $info{'downs'} = 0 if $info{'downs'} !~ /\d+/;
	    $info{'size'} = " " if $info{'size'} !~ /\d+.*/;
	    $info{'rating'} = 0 if $info{'rating'} !~ /\d+/;
	    $info{'desc'} = " " if $info{'desc'} eq "";
	    $info{'date'} = $Libs::API::localdate if $info{'date'} eq "";
    
    $self->db_do_query("UPDATE ${Libs::API::dbPrefix}_Module_Downloads
    				   SET DID=\"$did\",
		    			   Date=\"$info{'date'}\",
		    			   Author=\"$info{'author'}\",
		    			   Title=\"$info{'title'}\",
		    			   Description=\"$info{'desc'}\",
		    			   Size=\"$info{'size'}\",
		    			   URL=\"$info{'url'}\",
		    			   Rating=\"$info{'rating'}\"
				    WHERE DID=\"$info{'olddid'}\"") if !$new;
    
    if($new)
    {
    
    $self->db_do_query("INSERT INTO ${Libs::API::dbPrefix}_Module_Downloads
    				   VALUES (\"$did\",
		    			   \"$info{'date'}\",
		    			   \"$info{'author'}\",
		    			   \"$info{'title'}\",
		    			   \"$info{'desc'}\",
		    			   \"$info{'url'}\",
		    			   \"$info{'size'}\",
		    			   \"$info{'downs'}\",
		    			   \"$info{'rating'}\",
		    			   \"$info{'dir'}\")");
    
    $self->db_get_hash_query("SELECT FilesAdded FROM ${Libs::API::dbPrefix}_Module_Users
    					    WHERE UserName=\"$cook{'login'}\"","FilesAdded");

      my $t = $_{'FilesAdded'}+1;
      $self->db_do_query("UPDATE ${Libs::API::dbPrefix}_Module_Users
      				     SET FilesAdded=$t WHERE UserName=\"$cook{'login'}\"");
    }
    
    $self->db_disconnect(); # Disconnecting from DB.
    
    return "<br><b><center>  ...</b></center>";    
}
    
    
############################################
############################################

sub delDown
{
    my ($self, $did) = @_;
    
    ##################

	$self->db_connect();
	    $self->db_do_query("DELETE FROM ${Libs::API::dbPrefix}_Module_Downloads WHERE DID=\"$did\""); 
	$self->db_disconnect();
	    
    return 0;   
}

  ###################

}

1;
