#############################
#
#       nX - Contact
#         (Codename: XEN-Contact)
#            Admin Interface.
#
#     This script is a part of
#           XEN CMS
#
#     Writted by NeuroniX
#       aka Viguro Nikolay
#        neuronix666@yandex.ru
#
#         Started at 31/03/04
#
##############################

use Libs::ADI;

sub ContactAdmin
{
   my ($self, %info) = @_;
   my $center;
   my $total;
   my $globPrint;

      our $ADI = new Libs::ADI ( initMods => 1,
                                               readConf => 1 ); # Initalize ADI constructor

	$self->addAnswer(1, %info) if $info{'action'} eq "answer" && $info{'id'} =~ /\d+/ && $info{'answer'} ne "";
	$self->addAnswer(0, %info) if $info{'action'} eq "answer" && $info{'id'} =~ /\d+/;

   if($info{'type'} ne "answered")
     {

#===========================================

      $self->db_connect(); # Connecting to DB.

   	    my $sth = $Libs::API::dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Module_Contact WHERE IsAnswered<>1");
           $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
	          {
                   $total++;

		      $ref->{'Comments'} =~ s/\n/<br>/eg;

			my @html = $self->readFile("Skins/$Libs::API::skin/contact/AdmBlock.html");

			 foreach my $line (@html)
			   {
			        $line =~ s/__NUM__/$total/eg;
			   	$line =~ s/__USERNAME__/$ref->{'UserName'}/eg;
				$line =~ s/__DATE__/$ref->{'Date'}/eg;
				$line =~ s/__EMAIL__/$ref->{'EMail'}/eg;
				$line =~ s/__COMMENTS__/$ref->{'Comments'}/eg;

			  	$center .= $line;
	      	           }

		     $self->db_do_query("UPDATE ${Libs::API::dbPrefix}_Module_Contact SET IsNew='0' WHERE ID=\"$ref->{'ID'}\"");

                  }

           $sth->finish();

	   if($total == 0)
	    {
	      my @html = $self->readFile("Skins/$Libs::API::skin/contact/empty.html");

	      $center = "";

	       foreach my $line (@html)
	       {
		  $center .= $line;
	       }
	    }

     $self->db_disconnect();

	my @html = $self->readFile("Skins/$Libs::API::skin/contact/AdmForm.html");

	   foreach my $line (@html)
	    {
		$line =~ s/__MSGBLOCK__/$center/eg;
		$line =~ s/__SKIN__/$Libs::API::skin/eg;

		$globPrint .= $line;
	    }

      $ADI->printPage($globPrint);

#===========================================

     }
     else
     {

#===========================================
      $self->db_connect(); # Connecting to DB.

   	    my $sth = $Libs::API::dbh->prepare("SELECT * FROM ${Libs::API::dbPrefix}_Module_Contact WHERE IsAnswered<>0");
           $sth->execute();

               while (my $ref = $sth->fetchrow_hashref())
	          {
                   $total++;

		     $ref->{'Comments'} =~ s/\n/<br>/eg;

			my @html = $self->readFile("Skins/$Libs::API::skin/contact/AdmBlockAnsw.html");

			 foreach my $line (@html)
			   {
			        $line =~ s/__NUM__/$total/eg;
			   	$line =~ s/__USERNAME__/$ref->{'UserName'}/eg;
				$line =~ s/__DATE__/$ref->{'Date'}/eg;
				$line =~ s/__EMAIL__/$ref->{'EMail'}/eg;
				$line =~ s/__COMMENTS__/$ref->{'Comments'}/eg;
				$line =~ s/__ANSWER__/$ref->{'Answer'}/eg;

			  	$center .= $line;
	      	           }

                  }

           $sth->finish();

	   if($total == 0)
	    {
	      my @html = $self->readFile("Skins/$Libs::API::skin/contact/empty.html");

	      $center = "";

	       foreach my $line (@html)
	       {
		  $center .= $line;
	       }
	    }

     $self->db_disconnect();

	my @html = $self->readFile("Skins/$Libs::API::skin/contact/AdmForm.html");

	   foreach my $line (@html)
	    {
		$line =~ s/__MSGBLOCK__/$center/eg;
		$line =~ s/__SKIN__/$Libs::API::skin/eg;

		$globPrint .= $line;
	    }

      $ADI->printPage($globPrint);

#===========================================

sub addAnswer
{
   my ($self, $action, %info) = @_;
   my %conf = $self->readConfig("Config");

    $self->db_connect(); # Connecting to DB.
    $self->db_get_hash_query("SELECT * FROM ${Libs::API::dbPrefix}_Module_Contact WHERE ID=\"$info{'id'}\"", "UserName, EMail, Comments");

    my $user = $_{'UserName'};
    my $email = $_{'EMail'};
    my $comments = $_{'Comments'};

   if($action)
     {
open(SENDMAIL, "|$conf{'Sendmail'}") or print "Cant fork for sendmail: $!\n";
print SENDMAIL <<"EOF";
From: $conf{'SiteTitle'} Support <$conf{'AdminEMail'}>
To: $user <$email>
Subject:    .

$info{'answer'}

.

EOF

           close(SENDMAIL);

          $self->db_do_query("UPDATE ${Libs::API::dbPrefix}_Module_Contact SET IsAnswered='1', Answer=\"$info{'answer'}\" WHERE ID=\"$info{'id'}\"");
	  $self->db_disconnect();
	  $ADI->printPage("<br><center><b>  $user ($email) .</b></center>");

     }
     else
     {
	my @html = $self->readFile("Skins/$Libs::API::skin/contact/AdmAnsw.html");

	   foreach my $line (@html)
	    {
	        $line =~ s/__SKIN__/$Libs::API::skin/eg;
		$line =~ s/__USERNAME__/$user/eg;
		$line =~ s/__ID__/$info{'id'}/eg;
		$line =~ s/__EMAIL__/$email/eg;
		$line =~ s/__COMMENTS__/$comments/eg;

		$globPrint .= $line;
	    }

      $ADI->printPage($globPrint);

     }
}

#===========================================

     }
}

1;

